;------------------------------------------------------------------------------
; -----------------------
; File ....: ANTIVESA.ASM
; -----------------------
; Author...: Gus J Grubba
; Date ....: Aug, 1994
; O.S. ....: MS DOS
; Note ....: This is a simple and stupid TSR to get rid of the VESA driver so
;            the Vibrant driver won't take an eternity to load. For some reason,
;            when loading 3D Studio, the Vibrant Inline driver makes (directly
;            or indirectly) hundreds of calls into the VESA driver. The ATI
;            VESA support is slow and calling it repeateadly only makes it worse.
;
; Note ....: Copyleft 1994 Gus Grubba - All wrongs reserved.
;
;            This is a kludge. Use it at your own risk.
;
;            It's extremily simple minded. Once loaded, it will trap all VESA
;            calls and return doing nothing. If you want VESA again you must
;            reboot the computer and not load this thing (unless you have a
;            TSR unloader of some kind).
;
;            I don't check for anything. If you want, you could implement a
;            check to see if the TSR is already loaded and unload on command.
;            I just didn't have the time to do it and I couldn't care less for
;            VESA so...
;
;            gus@grubba.com
;
;            Copyright? Are you kidding? Who would want it? This thing is
;            thereby copylefted and it's up to anyone to do whatever you see
;            fit.
;
;
;------------------------------------------------------------------------------

  _TEXT                Segment    Byte
                       Assume     CS:_TEXT,DS:_TEXT

                       Org        100h

  Main:                Jmp        Near Ptr Initialize
                       db         00

  Old_10               dd         0

  Int10Handler         Proc
                       Sti

  ;------------------- VESA Call

                       Cmp        AH,4Fh                    ; VESA Call?
                       Je         BailOut                   ; Yep, skip
                       Jmp        Dword Ptr CS:Old_10       ; Nop, let BIOS handle it

  Bailout:             Iret                                 ; Just ignore it

  Int10Handler         Endp


  ;------------------- Go Resident

  Initialize:          Mov        DX,Offset LoadedText      ; Some silly text
                       Mov        AH,9                      ; Arcaic DOS
                       Int        21h                       ; Enter the deep hell of DOS

                       Mov        AX,3510h                  ; Get current Int 10h Vec
                       Int        21h                       ; Enter the deep hell of DOS
                       Mov        Word Ptr CS:Old_10,BX     ; Save localy
                       Mov        Word Ptr CS:Old_10[2],ES  ; Segment as well (dword)
                       Mov        DX,Offset Int10Handler    ; Our handler
                       Mov        AH,25h                    ; Set interrupt vector
                       Int        21h                       ; Enter the deep hell of DOS

  ;------------------- T.S.R.

                       Mov        DX,Offset Initialize      ; Up to what to keep resident
                       Int        27h                       ; This is it, dude!


  LoadedText           db         'ANTIVESA Version 36.12',13,10
                       db         'Copyleft 1994, Gus J Grubba',13,10
                       db         'VESA is no longer supported',13,10
                       db         '$'

  _TEXT                Ends

                       End        Main

;-- ANTIVESA.ASM --------------------------------------------------------------
