/*
 * FILE: frame.c
 * PROGRAMMER: Tom Asbury
 * PURPOSE: this file contains functions required to dump frame in RLE format
 */

#include <stdio.h> 
#include <math.h>
#include <GL/aux.h>
#include "view4d.h"

#define BUFFER_SIZE   512 

extern void dump_frame_32bits();

extern void
dump_frame_32bits(fp)
	FILE *fp;
/**********************************************************/
/* FUNCTION: dump_frame()                                 */
/**********************************************************/
{
        GLint x, y, old_pixel, buf[BUFFER_SIZE], new_pixel; 
	GLint fd, whole_line, ibuf;
	GLuint len;
	struct rle_header_struct header;

	fd = fileno(fp);

	header.width = width_of_window;
	header.height = height_of_window;
	header.bits_per_pixel = 8;

	write(fd, (char *) &header, sizeof(struct rle_header_struct));

	ibuf = 0;
        for (y = 0;y < height_of_window;y++) {
	    old_pixel = image[0][y];
	    len = 0;
	    whole_line = GL_FALSE;
            for (x = 1;x < width_of_window;x++) {
	       new_pixel = image[x][y];
	       if ((new_pixel != old_pixel)  || (len == 255) ||
			(len == (width_of_window - 1))) 
		{
		    buf[ibuf] = (len<<24) + old_pixel;
		    ibuf++;
		    if (ibuf == BUFFER_SIZE) {
			write(fd, (char *) buf, 4*ibuf);
			ibuf = 0;
		    }
		    old_pixel = new_pixel;
		    if (len == (width_of_window - 1)) whole_line = GL_TRUE;
		    len = 0;
		}
		else len++;
             }   
	     if (!whole_line) {
		 buf[ibuf] = (len<<24) + old_pixel;
		 ibuf++;
		 if (ibuf == BUFFER_SIZE) {
			write(fd, (char *) buf, 4*ibuf);
			ibuf = 0;
		 }
	     }
        }
	if (ibuf != 0) write(fd, (char *) buf, 4*ibuf);
}
